unit Address;

interface

uses
  Classes;

type
  TAddress = class
  public
    Name: string;
    Line1: string;
    Line2: string;
    City: string;
    Country: string;
  end;


  TAddressListFind = function (Address: TAddress): boolean;

  TAddressList = class(TList)
  protected
    function  GetAddress(Index: integer): TAddress;
    procedure PutAddress(Index: integer; Address: TAddress);
  public
    property Addresses[Index: integer]: TAddress read GetAddress write PutAddress;
    destructor Destroy; override;
    function Find(Find: TAddressListFind; var Found: integer):boolean;
  end;

implementation

function TAddressList.GetAddress(Index: integer): TAddress;
begin
  Result:=TAddress(Items[Index]);
end;

procedure TAddressList.PutAddress(Index: integer; Address: TAddress);
begin
  Items[Index]:=Address;
end;

destructor TAddressList.Destroy;
var
  Index: integer;
begin
  // free all of the objects first
  for Index:=0 to Count - 1 do
    TAddress(Items[Index]).Free;

  inherited;
end;

function TAddressList.Find(Find: TAddressListFind; var Found: integer):boolean;
var
  Index: integer;
begin
  Result:=False;
  Found:=-1;
  for Index:=0 to Count - 1 do
    if Find(TAddress(Items[Index])) then
    begin
      Result:=True;
      Found:=Index;
      Break;
    end;
end;

end.
