//----------------------------------------------------------------------------
// DBTree.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: DBTree.pas
//----------------------------------------------------------------------------
#ifndef DBTreeHPP
#define DBTreeHPP
//----------------------------------------------------------------------------
#include <DBGrids.hpp>
#include <DBTables.hpp>
#include <DB.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Dbtree
{
//-- type declarations -------------------------------------------------------
enum TNodeDisplayStrategy { ndsOnVisible, ndsOnTag };

enum TTreeSelectStrategy { tssOneSelect, tssMultiSelect, tssMultiSelectOnTag, tssMultiSelectOnLast, 
	tssMultiSelectOnOneLevel };

enum TTreeSelectBehaviour { tsbOneisNotMany, tsbOneisMany };

enum TTreeInsertStrategy { tisNoInsert, tisInsert };

enum TTreeNodePhase { tnpExpand, tnpCollapse };

enum TDBTreeViewAction { tvpNoAction, tvpExpandNode, tvpCollapseNode, tvpDeleteSelect, tvpCutSelect, 
	tvpCopySelect, tvpPasteSelect, tvpChangeSelect, tvpClearSelect, tvpRefreshSelect, tvpInsertNew };

typedef Set<TDBTreeViewAction, tvpNoAction, tvpInsertNew>  TDBTreeViewActions;

class __declspec(delphiclass) TDBTreeNode;
typedef void __fastcall (__closure *TTreeDBErrorEvent)(System::TObject* Sender, Db::EDatabaseError* 
	E, TDBTreeNode* NodeAt, Db::TDataSet* Table, const TDBTreeViewAction Action, Db::TDataAction &ErrAction
	);

typedef void __fastcall (__closure *TAskQueryEvent)(System::TObject* Sender, const int Level,  System::AnsiString &
	DatabaseName,  System::AnsiString &TableName,  System::AnsiString &MasterFields);

typedef void __fastcall (__closure *TTreeNodeActionEvent)(System::TObject* Sender, TDBTreeNode* NodeFrom
	, TDBTreeNode* NodeAt, Db::TDataSet* TableFrom, Db::TDataSet* TableAt, const TDBTreeViewAction Action
	, bool &Continue);

typedef void __fastcall (__closure *TTreeViewActionEvent)(System::TObject* Sender, TDBTreeNode* NodeAt
	, const TDBTreeViewAction Action, bool &Continue);

typedef void __fastcall (__closure *TFireActionEvent)(System::TObject* Sender, const TDBTreeViewAction 
	Action, const bool BeginPhase);

class __declspec(delphiclass) EDBTVWorkingTableError;
class __declspec(pascalimplementation) EDBTVWorkingTableError : public Db::EDatabaseError
{
	typedef Db::EDatabaseError inherited;
	
public:
	/* Exception.Create */ __fastcall EDBTVWorkingTableError(const System::AnsiString Msg) : Db::EDatabaseError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EDBTVWorkingTableError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Db::EDatabaseError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EDBTVWorkingTableError(int Ident) : Db::EDatabaseError(Ident) { }
		
	/* Exception.CreateResFmt */ __fastcall EDBTVWorkingTableError(int Ident, const System::TVarRec * Args
		, const int Args_Size) : Db::EDatabaseError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EDBTVWorkingTableError(const System::AnsiString Msg, int AHelpContext
		) : Db::EDatabaseError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EDBTVWorkingTableError(const System::AnsiString Msg, const 
		System::TVarRec * Args, const int Args_Size, int AHelpContext) : Db::EDatabaseError(Msg, Args, Args_Size
		, AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall EDBTVWorkingTableError(int Ident, int AHelpContext) : Db::
		EDatabaseError(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EDBTVWorkingTableError(int Ident, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Db::EDatabaseError(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EDBTVWorkingTableError(void) { }
	
};

class __declspec(delphiclass) EDBTVIndexNeededError;
class __declspec(pascalimplementation) EDBTVIndexNeededError : public Db::EDatabaseError
{
	typedef Db::EDatabaseError inherited;
	
public:
	/* Exception.Create */ __fastcall EDBTVIndexNeededError(const System::AnsiString Msg) : Db::EDatabaseError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EDBTVIndexNeededError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Db::EDatabaseError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EDBTVIndexNeededError(int Ident) : Db::EDatabaseError(Ident) { }
		
	/* Exception.CreateResFmt */ __fastcall EDBTVIndexNeededError(int Ident, const System::TVarRec * Args
		, const int Args_Size) : Db::EDatabaseError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EDBTVIndexNeededError(const System::AnsiString Msg, int AHelpContext
		) : Db::EDatabaseError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EDBTVIndexNeededError(const System::AnsiString Msg, const 
		System::TVarRec * Args, const int Args_Size, int AHelpContext) : Db::EDatabaseError(Msg, Args, Args_Size
		, AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall EDBTVIndexNeededError(int Ident, int AHelpContext) : Db::EDatabaseError(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EDBTVIndexNeededError(int Ident, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Db::EDatabaseError(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EDBTVIndexNeededError(void) { }
	
};

class __declspec(delphiclass) EDBTVMasterFieldsError;
class __declspec(pascalimplementation) EDBTVMasterFieldsError : public Db::EDatabaseError
{
	typedef Db::EDatabaseError inherited;
	
public:
	/* Exception.Create */ __fastcall EDBTVMasterFieldsError(const System::AnsiString Msg) : Db::EDatabaseError(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EDBTVMasterFieldsError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Db::EDatabaseError(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EDBTVMasterFieldsError(int Ident) : Db::EDatabaseError(Ident) { }
		
	/* Exception.CreateResFmt */ __fastcall EDBTVMasterFieldsError(int Ident, const System::TVarRec * Args
		, const int Args_Size) : Db::EDatabaseError(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EDBTVMasterFieldsError(const System::AnsiString Msg, int AHelpContext
		) : Db::EDatabaseError(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EDBTVMasterFieldsError(const System::AnsiString Msg, const 
		System::TVarRec * Args, const int Args_Size, int AHelpContext) : Db::EDatabaseError(Msg, Args, Args_Size
		, AHelpContext) { }
	/* Exception.CreateResHelp */ __fastcall EDBTVMasterFieldsError(int Ident, int AHelpContext) : Db::
		EDatabaseError(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EDBTVMasterFieldsError(int Ident, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Db::EDatabaseError(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EDBTVMasterFieldsError(void) { }
	
};



class __declspec(pascalimplementation) TDBTreeNode : public Comctrls::TTreeNode
{
	typedef Comctrls::TTreeNode inherited;
	
private:
	Db::TDataSource* FDataSource;
	void *FBookMark;
	
protected:
	Windows::TRect __fastcall Get_StateIconRect(void);
	void __fastcall Impact_SelectedNodesList(void);
	void __fastcall Change_RangeCheckStatus(void);
	void __fastcall Change_CheckStatus(void);
	
public:
	__fastcall TDBTreeNode(Comctrls::TTreeNodes* AOwner);
	__fastcall virtual ~TDBTreeNode(void);
	void __fastcall Collapsev2(void);
	void __fastcall Expandv2(void);
	void __fastcall Refresh(void);
	__property void * BookMark = {read=FBookMark, write=FBookMark, nodefault};
	
__published:
	__property Db::TDataSource* DataSource = {read=FDataSource, write=FDataSource, nodefault};
};

class __declspec(delphiclass) TDBBasicTreeView;
class __declspec(pascalimplementation) TDBBasicTreeView : public Comctrls::TTreeView
{
	typedef Comctrls::TTreeView inherited;
	
public:
	/* TCustomTreeView.Create */ __fastcall virtual TDBBasicTreeView(Classes::TComponent* AOwner) : Comctrls::
		TTreeView(AOwner) { }
	/* TCustomTreeView.Destroy */ __fastcall virtual ~TDBBasicTreeView(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TDBBasicTreeView(HWND ParentWindow) : Comctrls::TTreeView(
		ParentWindow) { }
	
};

class __declspec(delphiclass) TDBCommonTreeView;
class __declspec(pascalimplementation) TDBCommonTreeView : public TDBBasicTreeView
{
	typedef TDBBasicTreeView inherited;
	
private:
	bool bAutoScroll;
	System::AnsiString sSeparatorString;
	Db::TDataSource* dsLastDataSource;
	int iNbLevels;
	System::AnsiString sRootText;
	Classes::TList* lDSperLevel;
	TNodeDisplayStrategy eDisplayStrategy;
	TTreeSelectStrategy eSelectStrategy;
	TTreeSelectBehaviour eSelectBehaviour;
	Comctrls::TTreeNode* FLastSelectedNode;
	Classes::TList* lSelectedNodes;
	bool bCtrlActivated;
	bool bQueryControl;
	TTreeInsertStrategy eInsertStrategy;
	TTreeDBErrorEvent FOnTreeDBError;
	TAskQueryEvent FOnAskQuery;
	TTreeViewActionEvent FOnTreeViewAction;
	TTreeNodeActionEvent FOnTreeNodeAction;
	TFireActionEvent FOnFireAction;
	TDBTreeViewAction eActionInProgress;
	int iPopupX;
	int iPopupY;
	int iNbInError;
	int iNbMoved;
	int iNbCopied;
	int iNbDeleted;
	void __fastcall Reset_Counters(void);
	void __fastcall Set_LastDataSource(Db::TDataSource* Source);
	void __fastcall Set_RootText( System::AnsiString RootText);
	void __fastcall Set_SelectStrategy(TTreeSelectStrategy Strategy);
	void __fastcall Initialize_Tree(void);
	Classes::TList* __fastcall Get_SelectedNodes(void);
	TDBTreeViewActions __fastcall Get_TreeViewActions(void);
	HIDESBASE MESSAGE void __fastcall WMRButtonDown(Messages::TWMMouse &Message);
	void __fastcall Go_toBookMark(Comctrls::TTreeNode* Node);
	
protected:
	virtual bool __fastcall Verify_LastDataSource(Db::TDataSource* Source);
	virtual System::AnsiString __fastcall Build_DisplayString(Db::TDataSet* DataSet);
	virtual void __fastcall Set_ImageIndexes(Comctrls::TTreeNode* Node, TTreeNodePhase Phase);
	virtual void __fastcall Set_HasChildren(Comctrls::TTreeNode* Node, TTreeNodePhase Phase);
	virtual Db::TDataSource* __fastcall Get_ParentDataSource(Comctrls::TTreeNode* Node);
	virtual Db::TDataSource* __fastcall Get_CurrentDataSource(Comctrls::TTreeNode* Node);
	virtual void __fastcall Build_Collapse(Comctrls::TTreeNode* Node);
	virtual void __fastcall Build_Expand(Comctrls::TTreeNode* Node);
	virtual Comctrls::TTreeNode* __fastcall CreateNode(void);
	bool __fastcall Is_LevelToCheck(TDBTreeNode* Node);
	bool __fastcall Is_NodeToCheck(TDBTreeNode* Node);
	virtual void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall KeyUp(Word &Key, Classes::TShiftState Shift);
	virtual bool __fastcall CanChange(Comctrls::TTreeNode* Node);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall KeyPress(char &Key);
	virtual void __fastcall Compute_TreeMoves(int X, int Y);
	virtual void __fastcall DoEndDrag(System::TObject* Target, int X, int Y);
	virtual void __fastcall DragOver(System::TObject* Source, int X, int Y, Controls::TDragState State, 
		bool &Accept);
	virtual void __fastcall DragDrop(System::TObject* Source, int X, int Y);
	System::Variant __fastcall Build_KeyValuesList(Db::TDataSet* DataSet,  System::AnsiString MasterFields
		);
	System::Variant __fastcall Build_AllValuesList(Db::TDataSet* DataSet);
	void __fastcall Build_Names(Db::TDataSet* DataSet,  System::AnsiString &IndexField);
	void __fastcall Build_WorkingTable(TDBTreeNode* NodeAt, Db::TDataSet* DataSet, Dbtables::TTable* &Table
		,  System::AnsiString &MasterFields);
	void __fastcall Fill_ProcessList(Classes::TStringList* NodesList, bool FromSameLevel);
	virtual void __fastcall Perform_CopyOrMove(TDBTreeNode* NodeAt, TDBTreeViewAction CopyOrMove);
	__property Items  = {stored=false};
	virtual void __fastcall Do_TreeDBError(Db::EDatabaseError* E, TDBTreeNode* NodeAt, Db::TDataSet* Table
		, TDBTreeViewAction Action, Db::TDataAction &ErrAction);
	virtual void __fastcall Do_TreeViewAction(TDBTreeNode* NodeAt, TDBTreeViewAction Action, bool &Continue
		);
	virtual void __fastcall Do_TreeNodeAction(TDBTreeNode* CurrentNode, TDBTreeNode* NodeAt, Db::TDataSet* 
		CurrentDataSet, Db::TDataSet* NodeAtDataSet, TDBTreeViewAction Action, bool &Continue);
	virtual void __fastcall Do_AskQuery(const int Level,  System::AnsiString &DBName,  System::AnsiString &
		TName,  System::AnsiString &MFields);
	
public:
	virtual bool __fastcall CanCollapse(Comctrls::TTreeNode* Node);
	virtual bool __fastcall CanExpand(Comctrls::TTreeNode* Node);
	__fastcall virtual TDBCommonTreeView(Classes::TComponent* AOwner);
	__fastcall virtual ~TDBCommonTreeView(void);
	void __fastcall Delete(void);
	void __fastcall Move(TDBTreeNode* NodeAt);
	void __fastcall Copy(TDBTreeNode* NodeAt);
	System::AnsiString __fastcall Get_IndexFieldNames(Db::TDataSet* DataSet);
	virtual void __fastcall Fire_Action(TDBTreeViewAction Phase, bool BeginPhase);
	void __fastcall Execute_Action(TDBTreeNode* NodeAt, TDBTreeViewAction Action);
	void __fastcall Execute_PopupMenu(TDBTreeViewAction Action);
	void __fastcall Synchronize_On(TDBTreeNode* Node);
	void __fastcall FullCollapsev2(Comctrls::TTreeNode* Node);
	void __fastcall FullExpandv2(Comctrls::TTreeNode* Node);
	__property Classes::TList* SelectedNodes = {read=Get_SelectedNodes, nodefault};
	__property TDBTreeViewActions AllowedActions = {read=Get_TreeViewActions, nodefault};
	__property TDBTreeViewAction ActionInProgress = {read=eActionInProgress, nodefault};
	__property int NbCopied = {read=iNbCopied, nodefault};
	__property int NbDeleted = {read=iNbDeleted, nodefault};
	__property int NbMoved = {read=iNbMoved, nodefault};
	__property int NbInError = {read=iNbInError, nodefault};
	__property int NBLevels = {read=iNbLevels, nodefault};
	
__published:
	__property bool AutoScroll = {read=bAutoScroll, write=bAutoScroll, nodefault};
	__property System::AnsiString SeparatorString = {read=sSeparatorString, write=sSeparatorString, nodefault
		};
	__property Db::TDataSource* LastDataSource = {read=dsLastDataSource, write=Set_LastDataSource, nodefault
		};
	__property System::AnsiString RootText = {read=sRootText, write=Set_RootText, nodefault};
	__property bool QueryControl = {read=bQueryControl, write=bQueryControl, nodefault};
	__property TNodeDisplayStrategy DisplayStrategy = {read=eDisplayStrategy, write=eDisplayStrategy, nodefault
		};
	__property TTreeSelectStrategy SelectStrategy = {read=eSelectStrategy, write=Set_SelectStrategy, nodefault
		};
	__property TTreeSelectBehaviour SelectBehaviour = {read=eSelectBehaviour, write=eSelectBehaviour, nodefault
		};
	__property TTreeInsertStrategy InsertStrategy = {read=eInsertStrategy, write=eInsertStrategy, nodefault
		};
	__property TTreeDBErrorEvent OnTreeDBError = {read=FOnTreeDBError, write=FOnTreeDBError};
	__property TAskQueryEvent OnAskQuery = {read=FOnAskQuery, write=FOnAskQuery};
	__property TFireActionEvent OnFireAction = {read=FOnFireAction, write=FOnFireAction};
	__property TTreeNodeActionEvent OnTreeNodeAction = {read=FOnTreeNodeAction, write=FOnTreeNodeAction
		};
	__property TTreeViewActionEvent OnTreeViewAction = {read=FOnTreeViewAction, write=FOnTreeViewAction
		};
public:
	/* TWinControl.CreateParented */ __fastcall TDBCommonTreeView(HWND ParentWindow) : Dbtree::TDBBasicTreeView(
		ParentWindow) { }
	
};

class __declspec(delphiclass) TDBTreeView;
class __declspec(pascalimplementation) TDBTreeView : public TDBCommonTreeView
{
	typedef TDBCommonTreeView inherited;
	
protected:
	virtual void __fastcall Set_ImageIndexes(Comctrls::TTreeNode* Node, TTreeNodePhase Phase);
	virtual void __fastcall Set_HasChildren(Comctrls::TTreeNode* Node, TTreeNodePhase Phase);
public:
	/* TDBCommonTreeView.Create */ __fastcall virtual TDBTreeView(Classes::TComponent* AOwner) : Dbtree::
		TDBCommonTreeView(AOwner) { }
	/* TDBCommonTreeView.Destroy */ __fastcall virtual ~TDBTreeView(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TDBTreeView(HWND ParentWindow) : Dbtree::TDBCommonTreeView(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define STATEUNCHECKBOX (Byte)(1)
#define STATECHECKBOX (Byte)(2)
extern int STATEBOXARRAY[2];
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class TDBTreeViewActions ;

}	/* namespace Dbtree */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Dbtree;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// DBTree
