unit RtRegw;

interface

type
  TSaveKind = (skNone,skDef,skIni,skDll);
  TGenKind = (gkSingle,gkDouble);
  TRegKind = (rkNone,rkDef,rkDate,rkCount,rkUser);

procedure RTSetPCLock(Value: WordBool);

function RTRegister(ProductKey,UserKey,RegKey: PChar): WordBool;
function RTRegisterByFile(ProductKey,FileName: PChar): WordBool;

function RTGetUserKey(ProductKey,Value: PChar): WordBool;
function RTSetUserInfo(ProductKey,Info,Value: PChar): WordBool;
function RTGetUserInfo(ProductKey,Info,Value: PChar): WordBool;
function RTDelUserInfo(ProductKey,Info: PChar): WordBool;

function RTGetRegKind(ProductKey: PChar): TRegKind;
function RTIsReg(ProductKey: PChar): WordBool;
function RTDelReg(ProductKey: PChar): WordBool;
function RTCheckReg(ProductKey: PChar): longint;

function RTIsCountLock(ProductKey: PChar): WordBool;
function RTSetCountLock(ProductKey: PChar; Value: longint): WordBool;
function RTDelCountLock(ProductKey: PChar): WordBool;
function RTCheckCountLock(ProductKey: PChar): longint;

function RTIsDateLock(ProductKey: PChar): WordBool;
function RTSetDateLock(ProductKey: PChar; Value: longint): WordBool;
function RTDelDateLock(ProductKey: PChar): WordBool;
function RTCheckDateLock(ProductKey: PChar): longint;

function RTGetVersion: longint;
function RTGetGenKind: TGenKind;
function RTSetGenKind(Value: TGenKind): WordBool;
procedure RTSetEncodeKey(Value: PChar);

function RTGetSaveKind: TSaveKind;
function RTSetSaveKind(Value: TSaveKind): WordBool;
procedure RTGetSaveFile(Value: PChar);
function RTSetSaveFile(Value: PChar): WordBool;

function RTGetSafeKind: TSaveKind;
function RTSetSafeKind(Value: TSaveKind): WordBool;
procedure RTGetSafeFile(Value: PChar);
function RTSetSafeFile(Value: PChar): WordBool;
procedure RTGetBaseKey(Value: PChar);
function RTSetBaseKey(Value: PChar): WordBool;

function RTCheckLastDate(ProductKey: PChar): WordBool;

implementation

procedure RTSetPCLock;     external 'RTREGW';

function RTRegister;       external 'RTREGW';
function RTRegisterByFile; external 'RTREGW';

function RTGetUserKey;		external 'RTREGW';
function RTSetUserInfo;		external 'RTREGW';
function RTGetUserInfo;		external 'RTREGW';
function RTDelUserInfo;		external 'RTREGW';

function RTGetRegKind;     external 'RTREGW';
function RTIsReg;          external 'RTREGW';
function RTDelReg;         external 'RTREGW';
function RTCheckReg;       external 'RTREGW';

function RTIsCountLock;    external 'RTREGW';
function RTSetCountLock;   external 'RTREGW';
function RTDelCountLock;   external 'RTREGW';
function RTCheckCountLock; external 'RTREGW';

function RTIsDateLock;     external 'RTREGW';
function RTSetDateLock;    external 'RTREGW';
function RTDelDateLock;    external 'RTREGW';
function RTCheckDateLock;  external 'RTREGW';

function RTGetVersion;     external 'RTREGW';
function RTGetGenKind;		external 'RTREGW';
function RTSetGenKind;		external 'RTREGW';
procedure RTSetEncodeKey;  external 'RTREGW';

function RTGetSaveKind;    external 'RTREGW';
function RTSetSaveKind;    external 'RTREGW';
procedure RTGetSaveFile;	external 'RTREGW';
function RTSetSaveFile;		external 'RTREGW';
function RTGetSafeKind;    external 'RTREGW';
function RTSetSafeKind;    external 'RTREGW';
function RTSetSafeFile;		external 'RTREGW';
procedure RTGetSafeFile;	external 'RTREGW';
function RTSetBaseKey;		external 'RTREGW';
procedure RTGetBaseKey;		external 'RTREGW';

function RTCheckLastDate;	external 'RTREGW';

end.

