//-------------------------------------------------------------//
//                                                             //
//     MainClss.hpp                                            //
//     Header for MainClass (POPUPBOX)                         //
//     for Borland C++Builder                                  //
//     Copy this file into your C++Builder Include directory   //
//                                                             //
//-------------------------------------------------------------//

#ifndef MainClssHPP
#define MainClssHPP
//----------------------------------------------------------------------------
#include <Menus.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Mainclss
{
//-- type declarations -------------------------------------------------------
enum TPrxSpeedButtonStyle { prxSpBComboBox, prxSpBDown, prxSpBLeft, prxSpBRight, prxSpBUp, prxSpBEllipsis 
    };

class __declspec(delphiclass) TPrxSpeedButton;
class __declspec(pascalimplementation) TPrxSpeedButton : public Controls::TGraphicControl
{
    typedef Controls::TGraphicControl inherited;
    
private:
    bool FDown;
    bool FStayDown;
    TPrxSpeedButtonStyle FStyle;
    void __fastcall SetDown(bool p0);
    void __fastcall SetStyle(TPrxSpeedButtonStyle p0);
    
protected:
    virtual void __fastcall MouseDown(Controls::TMouseButton p0, Classes::TShiftState p1, int p2, int p3
        );
    virtual void __fastcall MouseUp(Controls::TMouseButton p0, Classes::TShiftState p1, int p2, int p3)
        ;
    virtual void __fastcall Paint(void);
    
public:
    __fastcall virtual TPrxSpeedButton(Classes::TComponent* p0);
    
__published:
    __property Align ;
    __property Caption ;
    __property bool Down = {read=FDown, write=SetDown, default=0};
    __property Enabled ;
    __property ShowHint ;
    __property bool StayDown = {read=FStayDown, write=FStayDown, default=0};
    __property TPrxSpeedButtonStyle Style = {read=FStyle, write=SetStyle, nodefault};
    __property Visible ;
    __property OnClick ;
    __property OnDblClick ;
    __property OnMouseDown ;
    __property OnMouseMove ;
    __property OnMouseUp ;
public:
    /* TGraphicControl.Destroy */ __fastcall virtual ~TPrxSpeedButton(void) { }
    
};

enum TPrxEditAlignShowBtn { ShowBtnNo, ShowBtnYes, ShowBtnFocus };

enum MainClss_2 { DropOnGetFocus, DropOnAltArrowKey };

typedef Set<MainClss_2, DropOnGetFocus, DropOnAltArrowKey>  TPrxEditAlignDropDownOn;

enum TPrxEditAlignDoOnReturnKey { doDefault, doGoAway, doNewLine };

class __declspec(delphiclass) TPrxCustomEditAlign;
class __declspec(pascalimplementation) TPrxCustomEditAlign : public Stdctrls::TCustomEdit
{
    typedef Stdctrls::TCustomEdit inherited;
    
private:
    TAlignment FAlignment;
    int FButtonWidth;
    bool FCaretAtEnd;
    TPrxEditAlignDoOnReturnKey FDoOnReturnKey;
    bool FEngage;
    bool FHideCaret;
    bool FIsPopped;
    Classes::TNotifyEvent FOnBtnClick;
    Classes::TNotifyEvent FOnBtnDblClick;
    Controls::TMouseEvent FOnBtnMouseDown;
    Controls::TMouseEvent FOnBtnMouseUp;
    Classes::TNotifyEvent FOnPopup;
    Classes::TNotifyEvent FOnShutup;
    TPrxEditAlignDropDownOn FDropDownOn;
    TPrxEditAlignShowBtn FShowButton;
    TPrxSpeedButtonStyle FShowButtonStyle;
    int FShowButtonWidth;
    bool FTrimText;
    bool FWordWrap;
    void __fastcall SetAlignment(Classes::TAlignment p0);
    void __fastcall SetCaretAtEnd(bool p0);
    void __fastcall SetEngage(bool p0);
    void __fastcall SetShowButton(TPrxEditAlignShowBtn p0);
    void __fastcall SetShowButtonStyle(TPrxSpeedButtonStyle p0);
    void __fastcall SetShowButtonWidth(int p0);
    void __fastcall SetWordWrap(bool p0);
    HIDESBASE MESSAGE void __fastcall CMEnabledChanged(Messages::TMessage &p0);
    HIDESBASE MESSAGE void __fastcall CMEnter(Messages::TWMNoParams &p0);
    HIDESBASE MESSAGE void __fastcall CMExit(Messages::TWMNoParams &p0);
    HIDESBASE MESSAGE void __fastcall WMEraseBkgnd(Messages::TWMEraseBkgnd &p0);
    HIDESBASE MESSAGE void __fastcall WMSetFocus(Messages::TWMSetFocus &p0);
    HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &p0);
    
protected:
    virtual void __fastcall Assemble(void);
    virtual void __fastcall BtnMouseDown(System::TObject* p0, Controls::TMouseButton p1, Classes::TShiftState 
        p2, int p3, int p4);
    virtual void __fastcall BtnMouseUp(System::TObject* p0, Controls::TMouseButton p1, Classes::TShiftState 
        p2, int p3, int p4);
    virtual void __fastcall CheckButton(void);
    virtual void __fastcall CreateParams(Controls::TCreateParams &p0);
    virtual void __fastcall CreateWnd(void);
    virtual void __fastcall GoAwayToNextControl(void);
    virtual void __fastcall KeyDown(Word &p0, Classes::TShiftState p1);
    virtual void __fastcall KeyPress(char &p0);
    virtual void __fastcall Popping(void);
    __property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, nodefault};
    __property bool CaretAtEnd = {read=FCaretAtEnd, write=SetCaretAtEnd, default=0};
    __property TPrxEditAlignDoOnReturnKey DoOnReturnKey = {read=FDoOnReturnKey, write=FDoOnReturnKey, default=0
        };
    __property bool Engage = {read=FEngage, write=SetEngage, default=1};
    __property TPrxEditAlignDropDownOn DropDownOn = {read=FDropDownOn, write=FDropDownOn, default=3};
    __property TPrxEditAlignShowBtn ShowButton = {read=FShowButton, write=SetShowButton, default=1};
    __property TPrxSpeedButtonStyle ShowButtonStyle = {read=FShowButtonStyle, write=SetShowButtonStyle, 
        default=0};
    __property int ShowButtonWidth = {read=FShowButtonWidth, write=SetShowButtonWidth, default=0};
    __property bool TrimText = {read=FTrimText, write=FTrimText, default=1};
    __property bool WordWrap = {read=FWordWrap, write=SetWordWrap, default=0};
    
public:
    TPrxSpeedButton* Button;
    __fastcall virtual TPrxCustomEditAlign(Classes::TComponent* p0);
    __fastcall virtual ~TPrxCustomEditAlign(void);
    void __fastcall InvalidateEditArea(bool p0);
    virtual void __fastcall PopItUp(void);
    virtual void __fastcall ShutItUp(void);
    __property int ButtonWidth = {read=FButtonWidth, nodefault};
    __property bool HideCaret = {read=FHideCaret, write=FHideCaret, nodefault};
    __property bool IsPopped = {read=FIsPopped, nodefault};
    
__published:
    __property Classes::TNotifyEvent OnBtnClick = {read=FOnBtnClick, write=FOnBtnClick};
    __property Classes::TNotifyEvent OnBtnDblClick = {read=FOnBtnDblClick, write=FOnBtnDblClick};
    __property Controls::TMouseEvent OnBtnMouseDown = {read=FOnBtnMouseDown, write=FOnBtnMouseDown};
    __property Controls::TMouseEvent OnBtnMouseUp = {read=FOnBtnMouseUp, write=FOnBtnMouseUp};
    __property Classes::TNotifyEvent OnPopup = {read=FOnPopup, write=FOnPopup};
    __property Classes::TNotifyEvent OnShutup = {read=FOnShutup, write=FOnShutup};
public:
    /* TWinControl.CreateParented */ __fastcall TPrxCustomEditAlign(HWND ParentWindow) : Stdctrls::TCustomEdit(
        ParentWindow) { }
    
};

class __declspec(delphiclass) TPrxEditAlign;
class __declspec(pascalimplementation) TPrxEditAlign : public TPrxCustomEditAlign
{
    typedef TPrxCustomEditAlign inherited;
    
__published:
    __property Alignment ;
    __property AutoSelect ;
    __property AutoSize ;
    __property BorderStyle ;
    __property CaretAtEnd ;
    __property CharCase ;
    __property Color ;
    __property Ctl3D ;
    __property DoOnReturnKey ;
    __property DragCursor ;
    __property DragMode ;
    __property DropDownOn ;
    __property Enabled ;
    __property Engage ;
    __property Font ;
    __property HideSelection ;
    __property MaxLength ;
    __property OEMConvert ;
    __property ParentColor ;
    __property ParentCtl3D ;
    __property ParentFont ;
    __property ParentShowHint ;
    __property PasswordChar ;
    __property PopupMenu ;
    __property ReadOnly ;
    __property ShowButton ;
    __property ShowButtonStyle ;
    __property ShowButtonWidth ;
    __property ShowHint ;
    __property TabOrder ;
    __property TabStop ;
    __property Text ;
    __property TrimText ;
    __property Visible ;
    __property WordWrap ;
    __property OnChange ;
    __property OnClick ;
    __property OnDblClick ;
    __property OnDragDrop ;
    __property OnDragOver ;
    __property OnEndDrag ;
    __property OnEnter ;
    __property OnExit ;
    __property OnKeyDown ;
    __property OnKeyPress ;
    __property OnKeyUp ;
    __property OnMouseDown ;
    __property OnMouseMove ;
    __property OnMouseUp ;
public:
    /* TPrxCustomEditAlign.Create */ __fastcall virtual TPrxEditAlign(Classes::TComponent* p0) : Mainclss::
        TPrxCustomEditAlign(p0) { }
    /* TPrxCustomEditAlign.Destroy */ __fastcall virtual ~TPrxEditAlign(void) { }
    
public:
    /* TWinControl.CreateParented */ __fastcall TPrxEditAlign(HWND ParentWindow) : Mainclss::TPrxCustomEditAlign(
        ParentWindow) { }
    
};

enum TPrxListBoxODStyle { fsNormal, fs3D, fsNoFocus };

class __declspec(delphiclass) TPrxCustomListBox;
class __declspec(pascalimplementation) TPrxCustomListBox : public Stdctrls::TCustomListBox
{
    typedef Stdctrls::TCustomListBox inherited;
    
private:
    int FLastSel;
    Classes::TNotifyEvent FOnChange;
    TAlignment FODAlignment;
    Graphics::TColor FODColorSelBG;
    Graphics::TColor FODColorSel;
    TPrxListBoxODStyle FODStyle;
    void __fastcall SetODAlignment(Classes::TAlignment p0);
    void __fastcall SetODColorSelBG(Graphics::TColor p0);
    void __fastcall SetODColorSel(Graphics::TColor p0);
    void __fastcall SetODStyle(TPrxListBoxODStyle p0);
    MESSAGE void __fastcall CNCtlColorListBox(Messages::TMessage &p0);
    HIDESBASE MESSAGE void __fastcall CNCommand(Messages::TWMCommand &p0);
    HIDESBASE MESSAGE void __fastcall CNDrawItem(Messages::TWMDrawItem &p0);
    MESSAGE void __fastcall LBSetCursel(Messages::TMessage &p0);
    HIDESBASE MESSAGE void __fastcall WMRButtonDown(Messages::TWMMouse &p0);
    
protected:
    virtual void __fastcall Change(int p0);
    virtual void __fastcall DrawItem(int p0, const Windows::TRect &p1, Stdctrls::TOwnerDrawState 
        p2);
    
public:
    __fastcall virtual TPrxCustomListBox(Classes::TComponent* p0);
    virtual void __fastcall DefaultDrawing(int p0, const Windows::TRect &p1);
    virtual System::AnsiString __fastcall GetItemIndirect(int p0);
    void __fastcall ResyncAfterItemLostSelection(void);
    __property Classes::TAlignment ODAlignment = {read=FODAlignment, write=SetODAlignment, default=0};
    __property Graphics::TColor ODColorSelBG = {read=FODColorSelBG, write=SetODColorSelBG, default=-2147483635
        };
    __property Graphics::TColor ODColorSel = {read=FODColorSel, write=SetODColorSel, default=-2147483634
        };
    __property TPrxListBoxODStyle ODStyle = {read=FODStyle, write=SetODStyle, default=0};
    
__published:
    __property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
public:
    /* TCustomListBox.Destroy */ __fastcall virtual ~TPrxCustomListBox(void) { }
    
public:
    /* TWinControl.CreateParented */ __fastcall TPrxCustomListBox(HWND ParentWindow) : Stdctrls::TCustomListBox(
        ParentWindow) { }
    
};

class __declspec(delphiclass) TPrxListBox;
class __declspec(pascalimplementation) TPrxListBox : public TPrxCustomListBox
{
    typedef TPrxCustomListBox inherited;
    
__published:
    __property Align ;
    __property BorderStyle ;
    __property Color ;
    __property Columns ;
    __property Ctl3D ;
    __property DragCursor ;
    __property DragMode ;
    __property Enabled ;
    __property ExtendedSelect ;
    __property Font ;
    __property IntegralHeight ;
    __property ItemHeight ;
    __property Items ;
    __property MultiSelect ;
    __property ParentColor ;
    __property ParentCtl3D ;
    __property ParentFont ;
    __property ParentShowHint ;
    __property PopupMenu ;
    __property ShowHint ;
    __property Sorted ;
    __property Style ;
    __property TabOrder ;
    __property TabStop ;
    __property TabWidth ;
    __property Visible ;
    __property OnClick ;
    __property OnDblClick ;
    __property OnDragDrop ;
    __property OnDragOver ;
    __property OnDrawItem ;
    __property OnEndDrag ;
    __property OnEnter ;
    __property OnExit ;
    __property OnKeyDown ;
    __property OnKeyPress ;
    __property OnKeyUp ;
    __property OnMeasureItem ;
    __property OnMouseDown ;
    __property OnMouseMove ;
    __property OnMouseUp ;
    __property OnStartDrag ;
    __property ODAlignment ;
    __property ODColorSel ;
    __property ODColorSelBG ;
    __property ODStyle ;
public:
    /* TPrxCustomListBox.Create */ __fastcall virtual TPrxListBox(Classes::TComponent* p0) : Mainclss::
        TPrxCustomListBox(p0) { }
    
public:
    /* TCustomListBox.Destroy */ __fastcall virtual ~TPrxListBox(void) { }
    
public:
    /* TWinControl.CreateParented */ __fastcall TPrxListBox(HWND ParentWindow) : Mainclss::TPrxCustomListBox(
        ParentWindow) { }
    
};

class __declspec(delphiclass) TPrxLBStringList;
class __declspec(delphiclass) TPrxCustomVListBox;
class __declspec(pascalimplementation) TPrxCustomVListBox : public TPrxCustomListBox
{
    typedef TPrxCustomListBox inherited;
    
private:
    int FItemIndex;
    TPrxLBStringList* FListItems;
    bool FSorted;
    int FTopIndex;
    HIDESBASE int __fastcall GetItemIndex(void);
    Stdctrls::TListBoxStyle __fastcall GetStyle(void);
    HIDESBASE int __fastcall GetTopIndex(void);
    HIDESBASE void __fastcall SetItemIndex(int p0);
    void __fastcall SetListItems(TPrxLBStringList* p0);
    HIDESBASE void __fastcall SetSorted(bool p0);
    HIDESBASE void __fastcall SetTopIndex(int p0);
    HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &p0);
    
protected:
    int FItemCount;
    virtual void __fastcall CreateWnd(void);
    virtual void __fastcall CreateParams(Controls::TCreateParams &p0);
    virtual void __fastcall DestroyWnd(void);
    int __fastcall GetItemCount(void);
    virtual System::AnsiString __fastcall GetItemIndirect(int p0);
    void __fastcall SetItemCount(int p0);
    
public:
    int __fastcall (__closure *MPGetItemCount)(void);
    System::AnsiString __fastcall (__closure *MPGetItemValue)(int Index);
    __fastcall virtual TPrxCustomVListBox(Classes::TComponent* p0);
    __fastcall virtual ~TPrxCustomVListBox(void);
    HIDESBASE void __fastcall Clear(void);
    bool __fastcall ValidSelection(void);
    __property int ItemCount = {read=GetItemCount, write=SetItemCount, nodefault};
    __property int ItemIndex = {read=GetItemIndex, write=SetItemIndex, nodefault};
    __property TPrxLBStringList* Items = {read=FListItems, write=SetListItems, nodefault};
    __property bool Sorted = {read=FSorted, write=SetSorted, default=0};
    __property Stdctrls::TListBoxStyle Style = {read=GetStyle, stored=false, nodefault};
    __property int TopIndex = {read=GetTopIndex, write=SetTopIndex, stored=false, nodefault};
public:
    /* TWinControl.CreateParented */ __fastcall TPrxCustomVListBox(HWND ParentWindow) : Mainclss::TPrxCustomListBox(
        ParentWindow) { }
    
};

class __declspec(pascalimplementation) TPrxLBStringList : public Classes::TStringList
{
    typedef Classes::TStringList inherited;
    
private:
    TPrxCustomVListBox* PrxVListBox;
    
protected:
    virtual void __fastcall HasChanged(System::TObject* p0);
    
public:
    __fastcall TPrxLBStringList(TPrxCustomVListBox* p0);
    virtual void __fastcall Delete(int p0);
    virtual void __fastcall Insert(int p0, const System::AnsiString p1);
    virtual void __fastcall Move(int p0, int p1);
    virtual void __fastcall SetUpdateState(bool p0);
public:
    /* TStringList.Destroy */ __fastcall virtual ~TPrxLBStringList(void) { }
    
};

class __declspec(delphiclass) TPrxVListBox;
class __declspec(pascalimplementation) TPrxVListBox : public TPrxCustomVListBox
{
    typedef TPrxCustomVListBox inherited;
    
__published:
    __property Align ;
    __property BorderStyle ;
    __property Color ;
    __property Columns ;
    __property Ctl3D ;
    __property DragCursor ;
    __property DragMode ;
    __property Enabled ;
    __property ExtendedSelect ;
    __property Font ;
    __property IntegralHeight ;
    __property ItemHeight ;
    __property Items ;
    __property MultiSelect ;
    __property ParentColor ;
    __property ParentCtl3D ;
    __property ParentFont ;
    __property ParentShowHint ;
    __property PopupMenu ;
    __property ShowHint ;
    __property Sorted ;
    __property TabOrder ;
    __property TabStop ;
    __property TabWidth ;
    __property Visible ;
    __property OnClick ;
    __property OnDblClick ;
    __property OnDragDrop ;
    __property OnDragOver ;
    __property OnDrawItem ;
    __property OnEndDrag ;
    __property OnEnter ;
    __property OnExit ;
    __property OnKeyDown ;
    __property OnKeyPress ;
    __property OnKeyUp ;
    __property OnMeasureItem ;
    __property OnMouseDown ;
    __property OnMouseMove ;
    __property OnMouseUp ;
    __property OnStartDrag ;
    __property Classes::TAlignment Alignment = {read=FODAlignment, write=SetODAlignment, default=0};
    __property Graphics::TColor ColorSelBG = {read=FODColorSelBG, write=SetODColorSelBG, default=-2147483635
        };
    __property Graphics::TColor ColorSel = {read=FODColorSel, write=SetODColorSel, default=-2147483634}
        ;
    __property TPrxListBoxODStyle Style = {read=FODStyle, write=SetODStyle, default=0};
public:
    /* TPrxCustomVListBox.Create */ __fastcall virtual TPrxVListBox(Classes::TComponent* p0) : Mainclss::
        TPrxCustomVListBox(p0) { }
    /* TPrxCustomVListBox.Destroy */ __fastcall virtual ~TPrxVListBox(void) { }
    
public:
    /* TWinControl.CreateParented */ __fastcall TPrxVListBox(HWND ParentWindow) : Mainclss::TPrxCustomVListBox(
        ParentWindow) { }
    
};

//-- var, const, procedure ---------------------------------------------------
extern int __fastcall GetCurrentFontHeight(HFONT p0);
//-- template instantiations -------------------------------------------------
template class TPrxEditAlignDropDownOn ;

}   /* namespace Mainclss */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Mainclss;
#endif
//-- end unit ----------------------------------------------------------------
#endif  // MainClss
