{!! Include file for TAPI service providers (TSP). The main library source
    file should use this file to specify exported functions }

{$IFDEF Tapi_Ver20}  {!!-------------------TAPI 2.0-------------------}

  exports
    TSPI_lineAccept,
    TSPI_lineAddToConference,
    TSPI_lineAnswer,
    TSPI_lineBlindTransfer,
    TSPI_lineClose,
    TSPI_lineCloseCall,
    TSPI_lineCompleteCall,
    TSPI_lineCompleteTransfer,
    TSPI_lineConditionalMediaDetection,
    TSPI_lineDevSpecific,
    TSPI_lineDevSpecificFeature,
    TSPI_lineDial,
    TSPI_lineDrop,
    TSPI_lineDropOnClose,
    TSPI_lineDropNoOwner,                                           
    TSPI_lineForward,
    TSPI_lineGatherDigits,
    TSPI_lineGenerateDigits,
    TSPI_lineGenerateTone,
    TSPI_lineGetAddressCaps,
    TSPI_lineGetAddressID,
    TSPI_lineGetAddressStatus,
    TSPI_lineGetCallAddressID,
    TSPI_lineGetCallInfo,
    TSPI_lineGetCallStatus,
    TSPI_lineGetDevCaps,
    TSPI_lineGetDevConfig,
    TSPI_lineGetExtensionID,
    TSPI_lineGetIcon,
    TSPI_lineGetID,
    TSPI_lineGetLineDevStatus,
    TSPI_lineGetNumAddressIDs,
    TSPI_lineHold,
    TSPI_lineMakeCall,
    TSPI_lineMonitorDigits,
    TSPI_lineMonitorMedia,
    TSPI_lineMonitorTones,
    TSPI_lineNegotiateExtVersion,
    TSPI_lineNegotiateTSPIVersion,
    TSPI_lineOpen,
    TSPI_linePark,
    TSPI_linePickup,
    TSPI_linePrepareAddToConference,
    TSPI_lineRedirect,
    TSPI_lineReleaseUserUserInfo,
    TSPI_lineRemoveFromConference,
    TSPI_lineSecureCall,
    TSPI_lineSelectExtVersion,
    TSPI_lineSendUserUserInfo,
    TSPI_lineSetAppSpecific,
    TSPI_lineSetCallParams,
    TSPI_lineSetCurrentLocation,
    TSPI_lineSetDefaultMediaDetection,
    TSPI_lineSetDevConfig,
    TSPI_lineSetMediaControl,
    TSPI_lineSetMediaMode,
    TSPI_lineSetStatusMessages,
    TSPI_lineSetTerminal,
    TSPI_lineSetupConference,
    TSPI_lineSetupTransfer,
    TSPI_lineSwapHold,
    TSPI_lineUncompleteCall,
    TSPI_lineUnhold,
    TSPI_lineUnpark,
    {$IFNDEF Tapi_NoSupportPhone}
    TSPI_phoneClose,
    TSPI_phoneDevSpecific,
    TSPI_phoneGetButtonInfo,
    TSPI_phoneGetData,
    TSPI_phoneGetDevCaps,
    TSPI_phoneGetDisplay,
    TSPI_phoneGetExtensionID,
    TSPI_phoneGetGain,
    TSPI_phoneGetHookSwitch,
    TSPI_phoneGetIcon,
    TSPI_phoneGetID,
    TSPI_phoneGetLamp,
    TSPI_phoneGetRing,
    TSPI_phoneGetStatus,
    TSPI_phoneGetVolume,
    TSPI_phoneNegotiateExtVersion,
    TSPI_phoneNegotiateTSPIVersion,
    TSPI_phoneOpen,
    TSPI_phoneSelectExtVersion,
    TSPI_phoneSetButtonInfo,
    TSPI_phoneSetData,
    TSPI_phoneSetDisplay,
    TSPI_phoneSetGain,
    TSPI_phoneSetHookSwitch,
    TSPI_phoneSetLamp,
    TSPI_phoneSetRing,
    TSPI_phoneSetStatusMessages,
    TSPI_phoneSetVolume,
    {$ENDIF}
    TSPI_providerCreateLineDevice,
    TSPI_providerCreatePhoneDevice,
    TSPI_providerEnumDevices,
    TSPI_providerInit,
    TSPI_providerInstall,
    TSPI_providerRemove,
    TSPI_providerShutdown,
  {$IFDEF Tapi_Ver20}
    TSPI_lineSetCallData,                                           
    TSPI_lineSetCallQualityOfService,
    TSPI_lineSetCallTreatment,                                      
    TSPI_lineSetLineDevStatus,                                      
    TSPI_providerFreeDialogInstance,                                
    TSPI_providerGenericDialogData,                                 
    TSPI_providerUIIdentify,                                        
    TUISPI_lineConfigDialog,                                        
    TUISPI_lineConfigDialogEdit,                                    
    {$IFNDEF Tapi_NoSupportPhone}
    TUISPI_phoneConfigDialog,
    {$ENDIF}
    TUISPI_providerConfig,                                          
    TUISPI_providerGenericDialog,                                   
    TUISPI_providerGenericDialogData,
    TUISPI_providerInstall,                                         
    TUISPI_providerRemove;
  {$ELSE}
    TSPI_lineConfigDialog,
    TSPI_lineConfigDialogEdit,
    {$IFNDEF Tapi_NoSupportPhone}
    TSPI_phoneConfigDialog,
   {$ENDIF}
    TSPI_providerConfig;
  {$ENDIF}

{$ELSE}  {!!-------------------TAPI 1.x-------------------}

  {!! TAPI 1.x requires TSP exports to be exported by ordinal }

  exports
    TSPI_lineAccept index _TSPI_LINEACCEPT,
    TSPI_lineAddToConference index _TSPI_LINEADDTOCONFERENCE,
    TSPI_lineAnswer index _TSPI_LINEANSWER,
    TSPI_lineBlindTransfer index _TSPI_LINEBLINDTRANSFER,
    TSPI_lineClose index _TSPI_LINECLOSE,
    TSPI_lineCloseCall index _TSPI_LINECLOSECALL,
    TSPI_lineCompleteCall index _TSPI_LINECOMPLETECALL,
    TSPI_lineCompleteTransfer index _TSPI_LINECOMPLETETRANSFER,
    TSPI_lineConditionalMediaDetection index _TSPI_LINECONDITIONALMEDIADETECTION,
    TSPI_lineDevSpecific index _TSPI_LINEDEVSPECIFIC,
    TSPI_lineDevSpecificFeature index _TSPI_LINEDEVSPECIFICFEATURE,
    TSPI_lineDial index _TSPI_LINEDIAL,
    TSPI_lineDrop index _TSPI_LINEDROP,
    TSPI_lineDropOnClose index _TSPI_LINEDROPONCLOSE,
    TSPI_lineDropNoOwner index _TSPI_LINEDROPNOOWNER,
    TSPI_lineForward index _TSPI_LINEFORWARD,
    TSPI_lineGatherDigits index _TSPI_LINEGATHERDIGITS,
    TSPI_lineGenerateDigits index _TSPI_LINEGENERATEDIGITS,
    TSPI_lineGenerateTone index _TSPI_LINEGENERATETONE,
    TSPI_lineGetAddressCaps index _TSPI_LINEGETADDRESSCAPS,
    TSPI_lineGetAddressID index _TSPI_LINEGETADDRESSID,
    TSPI_lineGetAddressStatus index _TSPI_LINEGETADDRESSSTATUS,
    TSPI_lineGetCallAddressID index _TSPI_LINEGETCALLADDRESSID,
    TSPI_lineGetCallInfo index _TSPI_LINEGETCALLINFO,
    TSPI_lineGetCallStatus index _TSPI_LINEGETCALLSTATUS,
    TSPI_lineGetDevCaps index _TSPI_LINEGETDEVCAPS,
    TSPI_lineGetDevConfig index _TSPI_LINEGETDEVCONFIG,
    TSPI_lineGetExtensionID index _TSPI_LINEGETEXTENSIONID,
    TSPI_lineGetIcon index _TSPI_LINEGETICON,
    TSPI_lineGetID index _TSPI_LINEGETID,
    TSPI_lineGetLineDevStatus index _TSPI_LINEGETLINEDEVSTATUS,
    TSPI_lineGetNumAddressIDs index _TSPI_LINEGETNUMADDRESSIDS,
    TSPI_lineHold index _TSPI_LINEHOLD,
    TSPI_lineMakeCall index _TSPI_LINEMAKECALL,
    TSPI_lineMonitorDigits index _TSPI_LINEMONITORDIGITS,
    TSPI_lineMonitorMedia index _TSPI_LINEMONITORMEDIA,
    TSPI_lineMonitorTones index _TSPI_LINEMONITORTONES,
    TSPI_lineNegotiateExtVersion index _TSPI_LINENEGOTIATEEXTVERSION,
    TSPI_lineNegotiateTSPIVersion index _TSPI_LINENEGOTIATETSPIVERSION,
    TSPI_lineOpen index _TSPI_LINEOPEN,
    TSPI_linePark index _TSPI_LINEPARK,
    TSPI_linePickup index _TSPI_LINEPICKUP,
    TSPI_linePrepareAddToConference index _TSPI_LINEPREPAREADDTOCONFERENCE,
    TSPI_lineRedirect index _TSPI_LINEREDIRECT,
    TSPI_lineReleaseUserUserInfo index _TSPI_LINERELEASEUSERUSERINFO,
    TSPI_lineRemoveFromConference index _TSPI_LINEREMOVEFROMCONFERENCE,
    TSPI_lineSecureCall index _TSPI_LINESECURECALL,
    TSPI_lineSelectExtVersion index _TSPI_LINESELECTEXTVERSION,
    TSPI_lineSendUserUserInfo index _TSPI_LINESENDUSERUSERINFO,
    TSPI_lineSetAppSpecific index _TSPI_LINESETAPPSPECIFIC,
    TSPI_lineSetCallParams index _TSPI_LINESETCALLPARAMS,
    TSPI_lineSetCurrentLocation index _TSPI_LINESETCURRENTLOCATION,
    TSPI_lineSetDefaultMediaDetection index _TSPI_LINESETDEFAULTMEDIADETECTION,
    TSPI_lineSetDevConfig index _TSPI_LINESETDEVCONFIG,
    TSPI_lineSetMediaControl index _TSPI_LINESETMEDIACONTROL,
    TSPI_lineSetMediaMode index _TSPI_LINESETMEDIAMODE,
    TSPI_lineSetStatusMessages index _TSPI_LINESETSTATUSMESSAGES,
    TSPI_lineSetTerminal index _TSPI_LINESETTERMINAL,
    TSPI_lineSetupConference index _TSPI_LINESETUPCONFERENCE,
    TSPI_lineSetupTransfer index _TSPI_LINESETUPTRANSFER,
    TSPI_lineSwapHold index _TSPI_LINESWAPHOLD,
    TSPI_lineUncompleteCall index _TSPI_LINEUNCOMPLETECALL,
    TSPI_lineUnhold index _TSPI_LINEUNHOLD,
    TSPI_lineUnpark index _TSPI_LINEUNPARK,
    {$IFNDEF Tapi_NoSupportPhone}
    TSPI_phoneClose index _TSPI_PHONECLOSE,
    TSPI_phoneDevSpecific index _TSPI_PHONEDEVSPECIFIC,
    TSPI_phoneGetButtonInfo index _TSPI_PHONEGETBUTTONINFO,
    TSPI_phoneGetData index _TSPI_PHONEGETDATA,
    TSPI_phoneGetDevCaps index _TSPI_PHONEGETDEVCAPS,
    TSPI_phoneGetDisplay index _TSPI_PHONEGETDISPLAY,
    TSPI_phoneGetExtensionID index _TSPI_PHONEGETEXTENSIONID,
    TSPI_phoneGetGain index _TSPI_PHONEGETGAIN,
    TSPI_phoneGetHookSwitch index _TSPI_PHONEGETHOOKSWITCH,
    TSPI_phoneGetIcon index _TSPI_PHONEGETICON,
    TSPI_phoneGetID index _TSPI_PHONEGETID,
    TSPI_phoneGetLamp index _TSPI_PHONEGETLAMP,
    TSPI_phoneGetRing index _TSPI_PHONEGETRING,
    TSPI_phoneGetStatus index _TSPI_PHONEGETSTATUS,
    TSPI_phoneGetVolume index _TSPI_PHONEGETVOLUME,
    TSPI_phoneNegotiateExtVersion index _TSPI_PHONENEGOTIATEEXTVERSION,
    TSPI_phoneNegotiateTSPIVersion index _TSPI_PHONENEGOTIATETSPIVERSION,
    TSPI_phoneOpen index _TSPI_PHONEOPEN,
    TSPI_phoneSelectExtVersion index _TSPI_PHONESELECTEXTVERSION,
    TSPI_phoneSetButtonInfo index _TSPI_PHONESETBUTTONINFO,
    TSPI_phoneSetData index _TSPI_PHONESETDATA,
    TSPI_phoneSetDisplay index _TSPI_PHONESETDISPLAY,
    TSPI_phoneSetGain index _TSPI_PHONESETGAIN,
    TSPI_phoneSetHookSwitch index _TSPI_PHONESETHOOKSWITCH,
    TSPI_phoneSetLamp index _TSPI_PHONESETLAMP,
    TSPI_phoneSetRing index _TSPI_PHONESETRING,
    TSPI_phoneSetStatusMessages index _TSPI_PHONESETSTATUSMESSAGES,
    TSPI_phoneSetVolume index _TSPI_PHONESETVOLUME,
    {$ENDIF}
    TSPI_providerCreateLineDevice index _TSPI_PROVIDERCREATELINEDEVICE,
    TSPI_providerCreatePhoneDevice index _TSPI_PROVIDERCREATEPHONEDEVICE,
    TSPI_providerEnumDevices index _TSPI_PROVIDERENUMDEVICES,
    TSPI_providerInit index _TSPI_PROVIDERINIT,
    TSPI_providerInstall index _TSPI_PROVIDERINSTALL,
    TSPI_providerRemove index _TSPI_PROVIDERREMOVE,
    TSPI_providerShutdown index _TSPI_PROVIDERSHUTDOWN,
    TSPI_lineConfigDialog index _TSPI_LINECONFIGDIALOG,
    TSPI_lineConfigDialogEdit index _TSPI_LINECONFIGDIALOGEDIT,
    {$IFNDEF Tapi_NoSupportPhone}
    TSPI_phoneConfigDialog index _TSPI_PHONECONFIGDIALOG,
    {$ENDIF}
    TSPI_providerConfig index _TSPI_PROVIDERCONFIG;

{$ENDIF}

